Index: issm/trunk/src/c/modules/ModelProcessorx/CreateDataSets.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateDataSets.cpp	(revision 4294)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateDataSets.cpp	(revision 4295)
@@ -16,5 +16,5 @@
 
 
-void CreateDataSets(Elements** pelements,Nodes** pnodes, Vertices** pvertices, Materials** pmaterials, Constraints** pconstraints, Loads** ploads,Parameters** pparameters,IoModel* iomodel,ConstDataHandle iomodel_handle,int solution_type,int analysis_type,int nummodels,int analysis_counter){
+void CreateDataSets(Elements** pelements,Nodes** pnodes, Vertices** pvertices, Materials** pmaterials, Constraints** pconstraints, Loads** ploads,Parameters** pparameters,IoModel* iomodel,ConstDataHandle iomodel_handle,const int solution_type,const int analysis_type,const int nummodels,int analysis_counter){
 
 	bool continuous=true;
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 4294)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 4295)
@@ -13,5 +13,5 @@
 #include "./ModelProcessorx.h"
 
-void	CreateElementsVerticesAndMaterials(Elements** pelements,Vertices** pvertices,Materials** pmaterials, IoModel* iomodel,ConstDataHandle iomodel_handle,int nummodels){
+void	CreateElementsVerticesAndMaterials(Elements** pelements,Vertices** pvertices,Materials** pmaterials, IoModel* iomodel,ConstDataHandle iomodel_handle,const int nummodels){
 
 	/*Intermediary*/
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 4294)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 4295)
@@ -12,5 +12,5 @@
 #include "./ModelProcessorx.h"
 
-void CreateParameters(Parameters** pparameters,IoModel* iomodel,ConstDataHandle iomodel_handle,int solution_type,int analysis_type,int analysis_counter){
+void CreateParameters(Parameters** pparameters,IoModel* iomodel,ConstDataHandle iomodel_handle,const int solution_type,int analysis_type,int analysis_counter){
 	
 	int i;
Index: issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.cpp	(revision 4294)
+++ issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.cpp	(revision 4295)
@@ -16,5 +16,5 @@
 #include "../../modules/modules.h"
 
-void ModelProcessorx(Elements** pelements, Nodes** pnodes, Vertices** pvertices, Materials** pmaterials, Constraints** pconstraints, Loads** ploads, Parameters** pparameters, ConstDataHandle IOMODEL,int solution_type,int nummodels, int* analysis_type_list){
+void ModelProcessorx(Elements** pelements, Nodes** pnodes, Vertices** pvertices, Materials** pmaterials, Constraints** pconstraints, Loads** ploads, Parameters** pparameters, ConstDataHandle IOMODEL,const int solution_type,const int nummodels,const int* analysis_type_list){
 
 	int i;
Index: issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.h
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.h	(revision 4294)
+++ issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.h	(revision 4295)
@@ -13,10 +13,10 @@
 #include "../../io/io.h"
 
-void ModelProcessorx(Elements** pelements, Nodes** pnodes, Vertices** pvertices, Materials** pmaterials, Constraints** pconstraints, Loads** ploads, Parameters** pparameters, ConstDataHandle iomodel_handle,int solution_type,int nummodels, int* analysis_type_list);
+void ModelProcessorx(Elements** pelements, Nodes** pnodes, Vertices** pvertices, Materials** pmaterials, Constraints** pconstraints, Loads** ploads, Parameters** pparameters, ConstDataHandle iomodel_handle,const int solution_type,const int nummodels,const int* analysis_type_list);
 
 /*Creation of fem datasets: general drivers*/
-void  CreateDataSets(Elements** pelements,Nodes** pnodes,Vertices** pvertices, Materials** pmaterials, Constraints** pconstraints, Loads** ploads,Parameters** pparameters,IoModel* iomodel,ConstDataHandle iomodel_handle,int solution_type,int analysis_type,int nummodels,int analysis_counter);
-void  CreateElementsVerticesAndMaterials(Elements** pelements,Vertices** pvertices,Materials** pmaterials, IoModel* iomodel,ConstDataHandle iomodel_handle,int nummodels);
-void  CreateParameters(Parameters** pparameters,IoModel* iomodel,ConstDataHandle iomodel_handle,int solution_type,int analysis_type,int analysis_counter);
+void  CreateDataSets(Elements** pelements,Nodes** pnodes,Vertices** pvertices, Materials** pmaterials, Constraints** pconstraints, Loads** ploads,Parameters** pparameters,IoModel* iomodel,ConstDataHandle iomodel_handle,const int solution_type,int analysis_type,const int nummodels,int analysis_counter);
+void  CreateElementsVerticesAndMaterials(Elements** pelements,Vertices** pvertices,Materials** pmaterials, IoModel* iomodel,ConstDataHandle iomodel_handle,const int nummodels);
+void  CreateParameters(Parameters** pparameters,IoModel* iomodel,ConstDataHandle iomodel_handle,const int solution_type,int analysis_type,int analysis_counter);
 void  CreateParametersControl(Parameters** pparameters,IoModel* iomodel,ConstDataHandle iomodel_handle,int analysis_type);
 void  CreateParametersQmu(Parameters** pparameters,IoModel* iomodel,ConstDataHandle iomodel_handle,int analysis_type);
@@ -33,5 +33,5 @@
 void	CreateNodesDiagnosticVert(Nodes** pnodes,IoModel* iomodel_handle,ConstDataHandle iomodel_handle);
 void	CreateConstraintsDiagnosticVert(Constraints** pconstraints,IoModel* iomodel,ConstDataHandle iomodel_handle);
-void    CreateLoadsDiagnosticVert(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
+void  CreateLoadsDiagnosticVert(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
 void	UpdateElementsDiagnosticVert(Elements* elements,IoModel* iomodel_handle,ConstDataHandle iomodel_handle,int analysis_counter,int analysis_type);
 
@@ -39,5 +39,5 @@
 void	CreateNodesDiagnosticHutter(Nodes** pnodes,IoModel* iomodel_handle,ConstDataHandle iomodel_handle);
 void	CreateConstraintsDiagnosticHutter(Constraints** pconstraints,IoModel* iomodel,ConstDataHandle iomodel_handle);
-void    CreateLoadsDiagnosticHutter(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
+void  CreateLoadsDiagnosticHutter(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
 void	UpdateElementsDiagnosticHutter(Elements* elements,IoModel* iomodel_handle,ConstDataHandle iomodel_handle,int analysis_counter,int analysis_type);
 
@@ -45,5 +45,5 @@
 void	CreateNodesDiagnosticStokes(Nodes** pnodes,IoModel* iomodel_handle,ConstDataHandle iomodel_handle);
 void	CreateConstraintsDiagnosticStokes(Constraints** pconstraints,IoModel* iomodel,ConstDataHandle iomodel_handle);
-void    CreateLoadsDiagnosticStokes(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
+void  CreateLoadsDiagnosticStokes(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
 void	UpdateElementsDiagnosticStokes(Elements* elements,IoModel* iomodel_handle,ConstDataHandle iomodel_handle,int analysis_counter,int analysis_type);
 
@@ -51,5 +51,5 @@
 void	CreateNodesSlopeCompute(Nodes** pnodes,IoModel* iomodel_handle,ConstDataHandle iomodel_handle);
 void	CreateConstraintsSlopeCompute(Constraints** pconstraints,IoModel* iomodel,ConstDataHandle iomodel_handle);
-void    CreateLoadsSlopeCompute(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
+void  CreateLoadsSlopeCompute(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
 void	UpdateElementsSlopeCompute(Elements* elements,IoModel* iomodel_handle,ConstDataHandle iomodel_handle,int analysis_counter,int analysis_type);
 
@@ -57,5 +57,5 @@
 void	CreateNodesThermal(Nodes** pnodes,IoModel* iomodel_handle,ConstDataHandle iomodel_handle);
 void	CreateConstraintsThermal(Constraints** pconstraints,IoModel* iomodel,ConstDataHandle iomodel_handle);
-void    CreateLoadsThermal(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
+void  CreateLoadsThermal(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
 void	UpdateElementsThermal(Elements* elements,IoModel* iomodel_handle,ConstDataHandle iomodel_handle,int analysis_counter,int analysis_type);
 
@@ -63,5 +63,5 @@
 void	CreateNodesMelting(Nodes** pnodes,IoModel* iomodel_handle,ConstDataHandle iomodel_handle);
 void	CreateConstraintsMelting(Constraints** pconstraints,IoModel* iomodel,ConstDataHandle iomodel_handle);
-void    CreateLoadsMelting(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
+void  CreateLoadsMelting(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
 void	UpdateElementsMelting(Elements* elements,IoModel* iomodel_handle,ConstDataHandle iomodel_handle,int analysis_counter,int analysis_type);
 
@@ -69,5 +69,5 @@
 void	CreateNodesPrognostic(Nodes** pnodes,IoModel* iomodel_handle,ConstDataHandle iomodel_handle);
 void	CreateConstraintsPrognostic(Constraints** pconstraints,IoModel* iomodel,ConstDataHandle iomodel_handle);
-void    CreateLoadsPrognostic(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
+void  CreateLoadsPrognostic(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
 void	UpdateElementsPrognostic(Elements* elements,IoModel* iomodel_handle,ConstDataHandle iomodel_handle,int analysis_counter,int analysis_type);
 
@@ -75,5 +75,5 @@
 void	CreateNodesPrognostic2(Nodes** pnodes,IoModel* iomodel_handle,ConstDataHandle iomodel_handle);
 void	CreateConstraintsPrognostic2(Constraints** pconstraints,IoModel* iomodel,ConstDataHandle iomodel_handle);
-void    CreateLoadsPrognostic2(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
+void  CreateLoadsPrognostic2(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
 void	UpdateElementsPrognostic2(Elements* elements,IoModel* iomodel_handle,ConstDataHandle iomodel_handle,int analysis_counter,int analysis_type);
 
@@ -81,10 +81,10 @@
 void	CreateNodesBalancedthickness(Nodes** pnodes,IoModel* iomodel_handle,ConstDataHandle iomodel_handle);
 void	CreateConstraintsBalancedthickness(Constraints** pconstraints,IoModel* iomodel,ConstDataHandle iomodel_handle);
-void    CreateLoadsBalancedthickness(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
+void  CreateLoadsBalancedthickness(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
 void	UpdateElementsBalancedthickness(Elements* elements,IoModel* iomodel_handle,ConstDataHandle iomodel_handle,int analysis_counter,int analysis_type);
 
 void	CreateNodesBalancedthickness2(Nodes** pnodes,IoModel* iomodel_handle,ConstDataHandle iomodel_handle);
 void	CreateConstraintsBalancedthickness2(Constraints** pconstraints,IoModel* iomodel,ConstDataHandle iomodel_handle);
-void    CreateLoadsBalancedthickness2(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
+void  CreateLoadsBalancedthickness2(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
 void	UpdateElementsBalancedthickness2(Elements* elements,IoModel* iomodel_handle,ConstDataHandle iomodel_handle,int analysis_counter,int analysis_type);
 
@@ -92,5 +92,5 @@
 void	CreateNodesBalancedvelocities(Nodes** pnodes,IoModel* iomodel_handle,ConstDataHandle iomodel_handle);
 void	CreateConstraintsBalancedvelocities(Constraints** pconstraints,IoModel* iomodel,ConstDataHandle iomodel_handle);
-void    CreateLoadsBalancedvelocities(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
+void  CreateLoadsBalancedvelocities(Loads** ploads, IoModel* iomodel, ConstDataHandle iomodel_handle);
 void	UpdateElementsBalancedvelocities(Elements* elements,IoModel* iomodel_handle,ConstDataHandle iomodel_handle,int analysis_counter,int analysis_type);
 
Index: issm/trunk/src/c/objects/FemModel.cpp
===================================================================
--- issm/trunk/src/c/objects/FemModel.cpp	(revision 4294)
+++ issm/trunk/src/c/objects/FemModel.cpp	(revision 4295)
@@ -20,5 +20,5 @@
 /*Object constructors and destructor*/
 /*FUNCTION FemModel::constructor {{{1*/
-FemModel::FemModel(ConstDataHandle IOMODEL,int in_solution_type,int* analyses, int nummodels){
+FemModel::FemModel(ConstDataHandle IOMODEL,const int in_solution_type,const int* analyses,const int nummodels){
 
 	/*intermediary*/
Index: issm/trunk/src/c/objects/FemModel.h
===================================================================
--- issm/trunk/src/c/objects/FemModel.h	(revision 4294)
+++ issm/trunk/src/c/objects/FemModel.h	(revision 4295)
@@ -54,5 +54,5 @@
 
 		/*constructors, destructors: */
-		FemModel(ConstDataHandle IOMODEL,int solution_type,int* analyses, int nummodels);
+		FemModel(ConstDataHandle IOMODEL,const int solution_type,const int* analyses,const int nummodels);
 		~FemModel();
 
Index: issm/trunk/src/c/shared/Dofs/DistributeNumDofs.cpp
===================================================================
--- issm/trunk/src/c/shared/Dofs/DistributeNumDofs.cpp	(revision 4294)
+++ issm/trunk/src/c/shared/Dofs/DistributeNumDofs.cpp	(revision 4295)
@@ -49,5 +49,5 @@
 		numdofs=1;
 	}
-	else ISSMERROR("%s%i%s"," analysis type: ",analysis_type,"  not implemented yet!");
+	else ISSMERROR("analysis type: %i (%s) not implemented yet",analysis_type,EnumAsString(analysis_type));
 
 	/*Assign output pointers:*/
Index: issm/trunk/src/c/solutions/balancedthickness.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/balancedthickness.cpp	(revision 4295)
@@ -34,6 +34,7 @@
 	double   start_init, finish_init;
 
-	int analyses[1]={BalancedthicknessAnalysisEnum};
-	int solution_type=BalancedthicknessAnalysisEnum;
+	const int numanalyses=1;
+	const int analyses[numanalyses]={BalancedthicknessAnalysisEnum};
+	const int solution_type=BalancedthicknessSolutionEnum;
 
 	MODULEBOOT();
@@ -63,5 +64,5 @@
 
 	_printf_("create finite element model:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,1);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */
Index: issm/trunk/src/c/solutions/balancedthickness2.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness2.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/balancedthickness2.cpp	(revision 4295)
@@ -35,6 +35,7 @@
 	double   start_init, finish_init;
 
-	int analyses[1]={Balancedthickness2AnalysisEnum};
-	int solution_type=Balancedthickness2AnalysisEnum;
+	const int numanalyses=1;
+	const int analyses[numanalyses]={Balancedthickness2AnalysisEnum};
+	const int solution_type=Balancedthickness2SolutionEnum;
 
 
@@ -65,5 +66,5 @@
 
 	_printf_("create finite element model:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,1);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */
Index: issm/trunk/src/c/solutions/balancedvelocities.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedvelocities.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/balancedvelocities.cpp	(revision 4295)
@@ -35,6 +35,7 @@
 	double   start_init, finish_init;
 
-	int analyses[1]={BalancedvelocitiesAnalysisEnum};
-	int solution_type=BalancedvelocitiesAnalysisEnum;
+	const int numanalyses=1;
+	const int analyses[numanalyses]={BalancedvelocitiesAnalysisEnum};
+	const int solution_type=BalancedvelocitiesSolutionEnum;
 
 	MODULEBOOT();
@@ -64,5 +65,5 @@
 
 	_printf_("create finite element model:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,1);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */
Index: issm/trunk/src/c/solutions/bedslope.cpp
===================================================================
--- issm/trunk/src/c/solutions/bedslope.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/bedslope.cpp	(revision 4295)
@@ -37,6 +37,7 @@
 	double   start_init, finish_init;
 
-	int analyses[1]={BedSlopeAnalysisEnum};
-	int solution_type=BedSlopeAnalysisEnum;
+	const int numanalyses=1;
+	const int analyses[numanalyses]={BedSlopeAnalysisEnum};
+	const int solution_type=BedSlopeSolutionEnum;
 
 	MODULEBOOT();
@@ -66,5 +67,5 @@
 
 	_printf_("create finite element model, using analyses types statically defined above:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,1);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */
Index: issm/trunk/src/c/solutions/diagnostic.cpp
===================================================================
--- issm/trunk/src/c/solutions/diagnostic.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/diagnostic.cpp	(revision 4295)
@@ -36,6 +36,7 @@
 	double   start_init, finish_init;
 
-	int analyses[5]={DiagnosticHorizAnalysisEnum,DiagnosticVertAnalysisEnum,DiagnosticStokesAnalysisEnum,DiagnosticHutterAnalysisEnum,SlopeAnalysisEnum};
-	int solution_type=DiagnosticAnalysisEnum;
+	const int numanalyses=6;
+	const int analyses[numanalyses]={DiagnosticHorizAnalysisEnum,DiagnosticVertAnalysisEnum,DiagnosticStokesAnalysisEnum,DiagnosticHutterAnalysisEnum,SurfaceSlopeAnalysisEnum,BedSlopeAnalysisEnum};
+	const int solution_type=DiagnosticAnalysisEnum;
 
 	MODULEBOOT();
@@ -64,5 +65,5 @@
 
 	_printf_("create finite element model:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,5);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */
Index: issm/trunk/src/c/solutions/prognostic.cpp
===================================================================
--- issm/trunk/src/c/solutions/prognostic.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/prognostic.cpp	(revision 4295)
@@ -35,6 +35,7 @@
 	double   start_init, finish_init;
 
-	int analyses[1]={PrognosticAnalysisEnum};
-	int solution_type=PrognosticAnalysisEnum;
+	const int numanalyses=1;
+	const int analyses[numanalyses]={PrognosticAnalysisEnum};
+	const int solution_type=PrognosticSolutionEnum;
 
 	MODULEBOOT();
@@ -64,5 +65,5 @@
 
 	_printf_("create finite element model:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,1);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */
Index: issm/trunk/src/c/solutions/prognostic2.cpp
===================================================================
--- issm/trunk/src/c/solutions/prognostic2.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/prognostic2.cpp	(revision 4295)
@@ -35,6 +35,7 @@
 	double   start_init, finish_init;
 
-	int analyses[1]={Prognostic2AnalysisEnum};
-	int solution_type=Prognostic2AnalysisEnum;
+	const int numanalyses=1;
+	const int analyses[numanalyses]={Prognostic2AnalysisEnum};
+	const int solution_type=Prognostic2SolutionEnum;
 
 	MODULEBOOT();
@@ -64,5 +65,5 @@
 
 	_printf_("create finite element model:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,1);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */
Index: issm/trunk/src/c/solutions/steadystate.cpp
===================================================================
--- issm/trunk/src/c/solutions/steadystate.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/steadystate.cpp	(revision 4295)
@@ -39,6 +39,7 @@
 	BoolParam* param=NULL;
 
-	int analyses[7]={DiagnosticHorizAnalysisEnum,DiagnosticVertAnalysisEnum,DiagnosticStokesAnalysisEnum,DiagnosticHutterAnalysisEnum,SlopeAnalysisEnum,ThermalAnalysisEnum,MeltingAnalysisEnum};
-	int solution_type=SteadystateAnalysisEnum;
+	const int numanalyses=7;
+	const int analyses[numanalyses]={DiagnosticHorizAnalysisEnum,DiagnosticVertAnalysisEnum,DiagnosticStokesAnalysisEnum,DiagnosticHutterAnalysisEnum,SlopeAnalysisEnum,ThermalAnalysisEnum,MeltingAnalysisEnum};
+	const int solution_type=SteadystateSolutionEnum;
 
 	MODULEBOOT();
@@ -68,5 +69,5 @@
 
 	_printf_("create finite element model:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,5);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */
Index: issm/trunk/src/c/solutions/surfaceslope.cpp
===================================================================
--- issm/trunk/src/c/solutions/surfaceslope.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/surfaceslope.cpp	(revision 4295)
@@ -37,6 +37,7 @@
 	double   start_init, finish_init;
 
-	int analyses[1]={SurfaceSlopeAnalysisEnum};
-	int solution_type=SurfaceSlopeAnalysisEnum;
+	const int numanalyses=1;
+	const int analyses[numanalyses]={SurfaceSlopeAnalysisEnum};
+	const int solution_type=SurfaceSlopeSolutionEnum;
 
 	MODULEBOOT();
@@ -66,5 +67,5 @@
 
 	_printf_("create finite element model, using analyses types statically defined above:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,1);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */
Index: issm/trunk/src/c/solutions/thermal.cpp
===================================================================
--- issm/trunk/src/c/solutions/thermal.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/thermal.cpp	(revision 4295)
@@ -37,6 +37,7 @@
 	double   start_init, finish_init;
 
-	int analyses[2]={ThermalAnalysisEnum,MeltingAnalysisEnum};
-	int solution_type=ThermalAnalysisEnum;
+	const int numanalyses=2;
+	const int analyses[numanalyses]={ThermalAnalysisEnum,MeltingAnalysisEnum};
+	const int solution_type=ThermalSolutionEnum;
 
 	MODULEBOOT();
@@ -66,5 +67,5 @@
 
 	_printf_("create finite element model:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,2);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */
Index: issm/trunk/src/c/solutions/transient2d.cpp
===================================================================
--- issm/trunk/src/c/solutions/transient2d.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/transient2d.cpp	(revision 4295)
@@ -35,6 +35,7 @@
 	double   start_init, finish_init;
 
-	int analyses[2]={DiagnosticHorizAnalysisEnum,PrognosticAnalysisEnum};
-	int solution_type=Transient2DAnalysisEnum;
+	const int numanalyses=2;
+	const int analyses[numanalyses]={DiagnosticHorizAnalysisEnum,PrognosticAnalysisEnum};
+	const int solution_type=Transient2DSolutionEnum;
 
 	MODULEBOOT();
@@ -61,5 +62,5 @@
 
 	_printf_("create finite element model:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,2);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */
Index: issm/trunk/src/c/solutions/transient3d.cpp
===================================================================
--- issm/trunk/src/c/solutions/transient3d.cpp	(revision 4294)
+++ issm/trunk/src/c/solutions/transient3d.cpp	(revision 4295)
@@ -35,6 +35,7 @@
 	double   start_init, finish_init;
 
-	int analyses[8]={DiagnosticHorizAnalysisEnum,DiagnosticVertAnalysisEnum,DiagnosticStokesAnalysisEnum,DiagnosticHutterAnalysisEnum,SlopeAnalysisEnum,PrognosticAnalysisEnum,ThermalAnalysisEnum,MeltingAnalysisEnum};
-	int solution_type=Transient3DAnalysisEnum;
+	const int numanalyses=8;
+	const int analyses[numanalyses]={DiagnosticHorizAnalysisEnum,DiagnosticVertAnalysisEnum,DiagnosticStokesAnalysisEnum,DiagnosticHutterAnalysisEnum,SlopeAnalysisEnum,PrognosticAnalysisEnum,ThermalAnalysisEnum,MeltingAnalysisEnum};
+	const int solution_type=Transient3DSolutionEnum;
 
 	MODULEBOOT();
@@ -61,5 +62,5 @@
 
 	_printf_("create finite element model:\n");
-	femmodel=new FemModel(fid,solution_type,analyses,8);
+	femmodel=new FemModel(fid,solution_type,analyses,numanalyses);
 
 	/*add outputfilename in parameters: */